from car_util import * # yeahh bad.

###############
# roof
##############

def roof_rear_pts(t, airbox_back, airbox_front, offs,
                  skip=True, doffs=0.0, hoffs=0.0, hoffup=0.1,
                  woff=0.0, xangle=0.0, yangle=-20.0):

    df = 0.0 # door fudge: align door window
    if skip:
        df = -0.00
    pts = []
    doffs = airbox_back[1] + doffs
    abht = airbox_back[2]
    pts.append([wpoints[4]-woff+df, doffs, abht-hoffs])
    pts.append([wpoints[3]-woff+df, doffs+0.02, h3-hoffup-hoffs])
    pts.append([wpoints[2]+woff, doffs+0.02, h3-hoffup-hoffs])
    pts.append([wpoints[1]+woff, doffs, abht-hoffs])

    b = []
    for p in pts:
        b.append(p)
    pts.reverse()
    for p in pts:
        b.append([-p[0], p[1], p[2]])

    base = []
    for i, (wd, d, height) in enumerate(b):
        pos = [wd + offs[0], d, height + offs[2]]
        base.append(pos)
        if skip and (i == 3 or i == 4): # skip the airbox_back point
            continue
        t.add_joint(pos, xangle=xangle, yangle=yangle)

    return base


class Roof(Group):

    def __init__(self):
        Group.__init__(self)
        self.dflt_pipe_diam = dthin

    def roofline_pts(self, airbox_back, airbox_front, airbox_front3, offs):

        base = roof_rear_pts(self, airbox_back, airbox_front, offs)

        # windscreen line
        screen = []
        d = -middle_fwd[-3] - 0.05
        woffs1 = 0.0145 # to separate forward-pipes at narrow triangle points
        #woffs2 = 0.020 # to separate forward-pipes at narrow triangle points
        woffs2 = woffs1 # thin pipes, they miss
        swids = [-wpoints[-2], -wpoints[-2]+woffs1,
                 -wpoints[1]-woffs2, -wpoints[1], # too close
                 wpoints[1], wpoints[1]+woffs2,   # needs further separation
                 wpoints[-2]-woffs1, wpoints[-2]]
        for i, wd in enumerate(swids):
            height = h3 + offs[2]
            doffs = 0.0
            if i in [2,3,4,5]:
                height -= 0.03 # coolness factor
                doffs = 0.04 # XXX needs to be calculated from windshield angle
            pos = [wd + offs[0], -doffs + d + offs[1], height]
            screen.append(pos)
            self.add_joint(pos)

        # mid-points roofline: 2 mids go to 1 screen each. screen reversed...
        mid = []
        ratio = 0.42
        for i in range(8):
            mid.append(pavg(screen[7-i], base[i], ratio))
        # ok adjust the roofline so that the top is level
        mid[2][2] = mid[1][2]
        mid[5][2] = mid[6][2]
        # and raise all roof midpoints
        for i in [1, 2, 5, 6]:
            mid[i][2] += 0.02
        for i, pos in enumerate(mid):
            yangle = 0
            if i == 0:
                yangle = -35
            if i == len(mid)-1:
                yangle = 35
            if i == 0 or i == len(mid)-1:
                xangle = 19
            else:
                xangle = 8
            self.add_joint(pos, xangle, yangle)

        # front door points
        doorpts = []
        dpt = airbox_front3[1] #, -middle_fwd[-2]+0.06+offs[1]
        windscreen_d = airbox_front[1] + 0.025
        windscreen_h = airbox_front[2] + 0.02
        doorpts.append([-wpoints[-1]+offs[0], dpt, h1+offs[2]])
        doorpts.append([-wpoints[-1]+offs[0], windscreen_d, windscreen_h])
        doorpts.append([wpoints[-1]+offs[0], windscreen_d, windscreen_h])
        doorpts.append([wpoints[-1]+offs[0], dpt, h1+offs[2]])
        for pos in doorpts:
            self.add_joint(pos)

        return base, mid, screen, doorpts

    def make(self, airbox_pts, bscoop, offs):
        aback, atop = airbox_pts
        airbox_back = atop[-1][0]
        airbox_front = atop[0][-1]
        airbox_front2 = atop[1][-1]
        airbox_front3 = aback[0][-1] # for door pillar point
        roofpts = self.roofline_pts(airbox_back, airbox_front,
                                    airbox_front3, offs)
        base, mid, screen, doorpts = roofpts

        # join mid to back roof lines, horizontal-forward
        for i in range(len(base)):
            offs1 = AUTO
            if i in [3,4]:
                offs1 = jfu
            self.add_pipe(base[i], mid[i], dthin, offs1)
        # diagonals on large back roof squares
        self.add_pipe(base[2], mid[1])
        self.add_pipe(base[4], mid[3], dthin, jrfu3)
        self.add_pipe(base[5], mid[6])

        # back roof line, across heads, joins to airbox.
        for i in range(len(base)-1):
            if i == 3:
                continue # already in airbox
            self.add_pipe(base[i], base[i+1])
        # mid roof line, across heads.
        for i in range(len(mid)-1):
            self.add_pipe(mid[i], mid[i+1], dthin)
        # front roof line, across windscreen.
        for i in range(1,len(screen)-1,2):
            self.add_pipe(screen[i], screen[i+1], dthick)

        # join forward-running roof lines from front to back
        for i in range(len(screen)):
            self.add_pipe(screen[i], mid[len(screen)-1-i])

        self.add_pipe(screen[3], mid[3]) # middle diagonal brace
        self.add_pipe(screen[1], mid[5]) # left diagonal
        self.add_pipe(screen[6], mid[2]) # right diagonal

        # ok connect outline of windshield
        self.add_pipe(screen[0], doorpts[1], dthick)
        self.add_pipe(screen[-1], doorpts[2], dthick)
        self.add_pipe(airbox_front, doorpts[1], dthick)
        self.add_pipe(airbox_front2, doorpts[2], dthick)

        # mid bracing to airbox
        for i in range(2):
            self.add_pipe(atop[1-i][1], mid[i+3])
        # remove to make driver headroom
        # self.add_pipe(atop[0][1], mid[3], dthin, jrbu3, jlfd3)

        # add a couple of cross-braces on the middle of the roof
        # above driver, to stabilise the roof section
        self.add_pipe(mid[2], mid[5])
        self.add_pipe(base[2], base[5])

        self.add_pipe(mid[3], screen[6], dthin, jright, jbd)
        self.add_pipe(mid[4], screen[1], dthin, jleft, jbd)

        # stabilise roof diagonal just above airbox
        self.add_pipe(base[4], mid[5], dthin, jup)
        self.add_pipe(base[3], mid[2], dthin, jup)

        return roofpts, self
